
#perl /home/xiangyang/Mazhongrui/Serotype_ST/Pneumo-Typer_v1.02/ST_tool/bacth_blat2.pl $path_fa $mlsa_database $mlsa_genename $thread_number $out_folder

use strict;
use warnings;
use threads;
use File::Basename qw<basename dirname>;
use vars qw(@loci_name);
#my $now_time = localtime;
#print "\n$now_time: start...\n\n";

my $path_fa = $ARGV[0];
my $mlsa_database = $ARGV[1];
my $mlsa_genename = $ARGV[2];
my $thread_number = $ARGV[3];
my $out_folder = $ARGV[4];
mkdir $out_folder;

opendir PATH_FA, $path_fa or die "could not open $path_fa";
my @PATH_FA = readdir PATH_FA; 
@PATH_FA =grep ($_!~/^\./ ,@PATH_FA);  #delete hidden file . ..
closedir PATH_FA;

my @loci_name;
open (NA, $mlsa_genename);
while(<NA>){
    chomp;
    @loci_name = split /\t/, $_;
}
close NA;
#############################################################################
#### do blast
#############################################################################



my $sub_file_number = scalar @PATH_FA;
if ($sub_file_number <= $thread_number) {
    $thread_number = $sub_file_number;
}

my $blast_fold = "$out_folder/cgblast_folder";
mkdir $blast_fold;
chdir $blast_fold;

my $blat_parse_dir = "$out_folder/cgblat_parse_dir";
mkdir $blat_parse_dir;


my $blat = `which blat`;
$blat =~ s/\n//g;


my @sub_function_parameters = ($path_fa, \@PATH_FA, $mlsa_database, $blat, $blast_fold, $blat_parse_dir);###edit


&bacth_blat($sub_file_number, $thread_number, "do_blat", \@sub_function_parameters);

#my $blat_out = "$out_folder/cgblastn_out.txt";
#chdir $blat_parse_dir;
#system ("find . -name '*.cgblastn_out' | xargs cat > $blat_out");  # For large number of files, directly using cat may causing error

#system ("rm -rf $blast_fold");
#chdir $blast_fold;

#my $finish_time = localtime;
#print "\n$finish_time: done!\n\n";
#########################################################
#########################################################
sub bacth_blat {

    my ($work_number, $thread_number, $subfunction, $sub_function_parameters) = @_;
    my ($path_fa, $input_dir, $dbdir, $blat, $blat_temp, $blat_dir) = @$sub_function_parameters;
 
    my @input = @$input_dir;
    my $thread;
    my @threads;
    my $job_number=0;
    print "    Blat_percent: ";
    while(){ 
        last if ($job_number>=$work_number);                         
        while(scalar(threads->list())<$thread_number) {     #set threadnumber；
            my $progress_record = int (($job_number/$work_number)*100);
            $job_number++; 
            #print "$job_number\n";                                
            my $input_file = "$path_fa/$input[$job_number-1]";
            my $Blast_perform_progress = int (($job_number/$work_number)*100); 
            print "$Blast_perform_progress%","..." if ($job_number == 1 or ( ($Blast_perform_progress%10 ==0) && ($progress_record <$Blast_perform_progress)) );

            $threads[$job_number-1]=threads->new(\&$subfunction, $input_file, $dbdir, $blat, $blat_temp, $blat_dir);   
            last if ($job_number eq $work_number);    
        }

        foreach $thread(threads->list(threads::all)){
            if($thread->is_joinable()) {              
                $thread->join();                     
            }
        }

    } 
 
    foreach my $th (threads->list(threads::all)) {
        $th->join();
    }
    print "done\n";
}



#########################################################
#########################################################
sub do_blat {
    my ($input, $db_dir, $blat, $blat_temp, $blat_dir) =@_;

    my $blatout_temp_dir = $blat_temp."/". (basename $input);
    mkdir $blatout_temp_dir;

    my $blatparse_out = $blat_dir."/".basename $input.".cgblastn_out";
    open (PAR_OUT, ">$blatparse_out");

    my @a = ("SPNE00213.fas", "cgMLSA_loci.fas");
    foreach my $db (@a){
        my $db_file = "$db_dir/$db";
        my $output = $blatout_temp_dir."/$db.blastout";
        system ("$blat $input $db_file $output -fastMap -noHead > temp.txt") if $db ne "SPNE00213.fas"; 
        system ("$blat $input $db_file $output -noHead > temp.txt") if $db eq "SPNE00213.fas"; #-fastMap could not be used due to the sequence length for "SPNE00213.fas" is >5000
    }  
    my $outputfinal = $blatout_temp_dir."/final.blastout";
    system ("cat $blatout_temp_dir/* > $outputfinal");

    #################################    
    open (OT, $outputfinal);
    my @gene_loci;
    while (<OT>){    
        chomp;
        $_ =~ s/ //g;
        my @array = split /\t/, $_;
        my $sum = $array[1]+$array[2]+$array[3]+$array[4]+$array[5]+$array[6]+$array[7];
        if ( ($array[0] eq $array[10]) && ($sum == 0) ){
            print PAR_OUT "T\t$array[13]\t$array[9]\t$array[15]\t$array[16]\t$array[10]\t$array[0]\n";
            my $na = $array[9];
            $na =~ s/_.*//g; 
            push @gene_loci, $na;

        }
    }
    close OT;

    my $strain = basename $input;
    foreach my $e(@loci_name){             
        print PAR_OUT "F\t$strain\t$e\tNo hit\n" if !grep{$e eq $_}@gene_loci; 
        #print "$e\n" if !grep{$e eq $_}@gene_loci; 
    } 

    #################################
    close PAR_OUT;
    
    system ("rm -rf $blatout_temp_dir");
}




